/* prints out details about screens and monitors connected to this X display
 * compile with:
 *   gcc -o enum-displays enum-displays.c `pkg-config gtk+-2.0 gdk-2.0 --cflags --libs`
 */
#include <gdk/gdk.h>
#include <gtk/gtk.h>

int
main (int argc, char **argv)
{
    gint i, j, nscreens, nmonitors;
    GdkDisplay *gdpy;
    GdkScreen *gscreen;
    gchar *display_name;
    GdkRectangle geom;
    
    gdk_init (&argc, &argv);
    gdpy = gdk_display_get_default ();
    nscreens = gdk_display_get_n_screens (gdpy);
    g_print ("\nThis display has %d screen%s.\n\n", nscreens,
        nscreens > 1 ? "s" : "");

    for (i = 0; i < nscreens; ++i)
    {
        gscreen = gdk_display_get_screen (gdpy, i);

        g_print ("Screen %d:\n", i);

        display_name = gdk_screen_make_display_name (gscreen);
        g_print ("  Name:  %s\n  Size: %dx%d\n", display_name,
            gdk_screen_get_width (gscreen), gdk_screen_get_height (gscreen));
        g_free (display_name);

        nmonitors = gdk_screen_get_n_monitors (gscreen);
        g_print ("  %d monitor%s connected:\n", nmonitors,
            nmonitors > 1 ? "s" : "");
        for (j = 0; j < nmonitors; ++j)
        {
            gdk_screen_get_monitor_geometry (gscreen, j, &geom);
            g_print ("    Monitor %d: %dx%d+%d+%d\n", j, geom.width,
                geom.height, geom.x, geom.y);
        }
    }
    g_print ("\n");
    return 0;
}

